ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.42 by greg, Tue Apr 23 23:22:09 2013 UTC vs.
Revision 2.51 by greg, Thu Mar 12 13:24:41 2015 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10   use File::Temp qw/ :mktemp  /;
11   sub userror {
12 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-W][-t{3|4} Nlog2][-r \"ropts\"][-f \"x=string;y=string\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}C][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13          exit 1;
14   }
15 < my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
16 < chomp $td;
15 > my ($td,$radscn,$mgfscn,$octree,$fsender,$bsender,$receivers,$facedat,$behinddat,$rmtmp);
16 > my ($tf,$rf,$tb,$rb,$tfx,$rfx,$tbx,$rbx,$tfz,$rfz,$tbz,$rbz);
17 > if ($windoz) {
18 >        my $tmploc = `echo \%TMP\%`;
19 >        chomp($tmploc);
20 >        $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
21 >        $radscn = "$td\\device.rad";
22 >        $mgfscn = "$td\\device.mgf";
23 >        $octree = "$td\\device.oct";
24 >        $fsender = "$td\\fsender.rad";
25 >        $bsender = "$td\\bsender.rad";
26 >        $receivers = "$td\\receivers.rad";
27 >        $facedat = "$td\\face.dat";
28 >        $behinddat = "$td\\behind.dat";
29 >        $tf = "$td\\tf.dat";
30 >        $rf = "$td\\rf.dat";
31 >        $tb = "$td\\tb.dat";
32 >        $rb = "$td\\rb.dat";
33 >        $tfx = "$td\\tfx.dat";
34 >        $rfx = "$td\\rfx.dat";
35 >        $tbx = "$td\\tbx.dat";
36 >        $rbx = "$td\\rbx.dat";
37 >        $tfz = "$td\\tfz.dat";
38 >        $rfz = "$td\\rfz.dat";
39 >        $tbz = "$td\\tbz.dat";
40 >        $rbz = "$td\\rbz.dat";
41 >        chomp $td;
42 >        $rmtmp = "rmdir /S /Q $td";
43 > } else {
44 >        $td = mkdtemp("/tmp/genBSDF.XXXXXX");
45 >        chomp $td;
46 >        $radscn = "$td/device.rad";
47 >        $mgfscn = "$td/device.mgf";
48 >        $octree = "$td/device.oct";
49 >        $fsender = "$td/fsender.rad";
50 >        $bsender = "$td/bsender.rad";
51 >        $receivers = "$td/receivers.rad";
52 >        $facedat = "$td/face.dat";
53 >        $behinddat = "$td/behind.dat";
54 >        $tf = "$td/tf.dat";
55 >        $rf = "$td/rf.dat";
56 >        $tb = "$td/tb.dat";
57 >        $rb = "$td/rb.dat";
58 >        $tfx = "$td/tfx.dat";
59 >        $rfx = "$td/rfx.dat";
60 >        $tbx = "$td/tbx.dat";
61 >        $rbx = "$td/rbx.dat";
62 >        $tfz = "$td/tfz.dat";
63 >        $rfz = "$td/rfz.dat";
64 >        $tbz = "$td/tbz.dat";
65 >        $rbz = "$td/rbz.dat";
66 >        $rmtmp = "rm -rf $td";
67 > }
68   my @savedARGV = @ARGV;
69 + my $rfluxmtx = "rfluxmtx -v -ab 5 -ad 700 -lw 3e-6";
70 + my $wrapper = "wrapBSDF";
71   my $tensortree = 0;
72   my $ttlog2 = 4;
73   my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
74   my $mgfin = 0;
75   my $geout = 1;
76   my $nproc = 1;
77 + my $docolor = 0;
78   my $doforw = 0;
79   my $doback = 1;
80   my $pctcull = 90;
81   my $gunit = "meter";
82 + my $curspec = "Visible";
83   my @dim;
84   # Get options
85   while ($#ARGV >= 0) {
86          if ("$ARGV[0]" =~ /^[-+]m/) {
87                  $mgfin = ("$ARGV[0]" =~ /^\+/);
88          } elsif ("$ARGV[0]" eq "-r") {
89 <                $rtargs = "$rtargs $ARGV[1]";
89 >                $rfluxmtx .= " $ARGV[1]";
90                  shift @ARGV;
91          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
92                  $geout = ("$ARGV[0]" =~ /^\+/);
# Line 40 | Line 95 | while ($#ARGV >= 0) {
95                          die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
96                  }
97                  shift @ARGV;
98 +        } elsif ("$ARGV[0]" =~ /^[-+]C/) {
99 +                $docolor = ("$ARGV[0]" =~ /^\+/);
100          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
101                  $doforw = ("$ARGV[0]" =~ /^\+/);
102          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
# Line 52 | Line 109 | while ($#ARGV >= 0) {
109                  $tensortree = substr($ARGV[0], 2, 1);
110                  $ttlog2 = $ARGV[1];
111                  shift @ARGV;
112 +        } elsif ("$ARGV[0]" eq "-f") {
113 +                $wrapper .= " -f \"$ARGV[1]\"";
114 +                shift @ARGV;
115 +        } elsif ("$ARGV[0]" eq "-W") {
116 +                $wrapper .= " -W";
117          } elsif ("$ARGV[0]" eq "-c") {
118                  $nsamp = $ARGV[1];
119                  shift @ARGV;
# Line 71 | Line 133 | while ($#ARGV >= 0) {
133   }
134   # Check that we're actually being asked to do something
135   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
136 + # Issue warning for unhandled reciprocity case
137 + print STDERR "Warning: recommend both +forward and +backward with -t3\n" if
138 +                ($tensortree==3 && !($doforw && $doback));
139 + $wrapper .= $tensortree ? " -a t$tensortree" : " -a kf -c";
140 + $wrapper .= " -u $gunit";
141   # Get scene description and dimensions
75 my $radscn = "$td/device.rad";
76 my $mgfscn = "$td/device.mgf";
77 my $octree = "$td/device.oct";
142   if ( $mgfin ) {
143 <        system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
143 >        system "mgf2rad @ARGV > $radscn";
144          die "Could not load MGF input\n" if ( $? );
81        system "mgf2rad $mgfscn > $radscn";
145   } else {
146          system "xform -e @ARGV > $radscn";
147          die "Could not load Radiance input\n" if ( $? );
85        system "rad2mgf $radscn > $mgfscn" if ( $geout );
148   }
149   if ($#dim != 5) {
150          @dim = split ' ', `getbbox -h $radscn`;
151   }
152   print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
153 < # Add receiver surfaces (rectangular)
154 < my $fmodnm="receiver_face";
93 < my $bmodnm="receiver_behind";
94 < open(RADSCN, ">> $radscn");
95 < print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
96 < print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
97 < print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
98 < print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
99 < close RADSCN;
153 > $wrapper .= ' -f "t=' . ($dim[5] - $dim[4]) . ';w=' . ($dim[1] - $dim[0]) .
154 >                ';h=' . ($dim[3] - $dim[2]) . '"';
155   # Generate octree
156   system "oconv -w $radscn > $octree";
157   die "Could not compile scene\n" if ( $? );
158 < # Output XML prologue
104 < print
105 < '<?xml version="1.0" encoding="UTF-8"?>
106 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 < ';
108 < print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 < print
110 < '<WindowElementType>System</WindowElementType>
111 < <FileType>BSDF</FileType>
112 < <Optical>
113 < <Layer>
114 <        <Material>
115 <                <Name>Name</Name>
116 <                <Manufacturer>Manufacturer</Manufacturer>
117 < ';
118 < printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119 < printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120 < printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 < print "\t\t<DeviceType>Other</DeviceType>\n";
122 < print " </Material>\n";
123 < # Output MGF description if requested
158 > # Add MGF description if requested
159   if ( $geout ) {
160 <        print "\t<Geometry format=\"MGF\">\n";
161 <        print "\t\t<MGFblock unit=\"$gunit\">\n";
127 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
128 <        open(MGFSCN, "< $mgfscn");
129 <        while (<MGFSCN>) { print $_; }
160 >        open(MGFSCN, "> $mgfscn");
161 >        printf MGFSCN "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
162          close MGFSCN;
163 <        print "xf\n";
164 <        print "</MGFblock>\n";
165 <        print "\t</Geometry>\n";
163 >        if ( $mgfin ) {
164 >                system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV >> $mgfscn};
165 >        } else {
166 >                system "rad2mgf $radscn >> $mgfscn";
167 >        }
168 >        open(MGFSCN, ">> $mgfscn");
169 >        print MGFSCN "xf\n";
170 >        close MGFSCN;
171 >        $wrapper .= " -g $mgfscn";
172   }
173 < # Set up surface sampling
174 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
175 < my $ny = int($nsamp/$nx + .5);
173 > # Create receiver & sender surfaces (rectangular)
174 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
175 > my $ny = int($nsamp/$nx + 1);
176   $nsamp = $nx * $ny;
177   my $ns = 2**$ttlog2;
178 < my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
178 > open(RADSCN, "> $receivers");
179 > print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=sc$ns\n" : "h=kf\n");
180 > print RADSCN '#@rfluxmtx ' . "u=Y o=$facedat\n\n";
181 > print RADSCN "void glow receiver_face\n0\n0\n4 1 1 1 0\n\n";
182 > print RADSCN "receiver_face source f_receiver\n0\n0\n4 0 0 1 180\n\n";
183 > print RADSCN '#@rfluxmtx ' . "u=Y o=$behinddat\n\n";
184 > print RADSCN "void glow receiver_behind\n0\n0\n4 1 1 1 0\n\n";
185 > print RADSCN "receiver_behind source b_receiver\n0\n0\n4 0 0 -1 180\n";
186 > close RADSCN;
187 > # Finish rfluxmtx command and prepare sender surfaces
188 > $rfluxmtx .= " -n $nproc -c $nsamp";
189 > if ( $tensortree != 3 ) {       # Isotropic tensor tree is exception
190 >        open (RADSCN, "> $fsender");
191 >        print RADSCN '#@rfluxmtx u=Y ' . ($tensortree ? "h=sc$ns\n\n" : "h=kf\n\n");
192 >        print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
193 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[2], $dim[4];
194 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[3], $dim[4];
195 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[3], $dim[4];
196 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[2], $dim[4];
197 >        close RADSCN;
198 >        open (RADSCN, "> $bsender");
199 >        print RADSCN '#@rfluxmtx u=Y ' . ($tensortree ? "h=sc$ns\n\n" : "h=kf\n\n");
200 >        print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
201 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[2], $dim[5];
202 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[2], $dim[5];
203 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[1], $dim[3], $dim[5];
204 >        printf RADSCN "\t%f\t%f\t%f\n", $dim[0], $dim[3], $dim[5];
205 >        close RADSCN;
206 > }
207   # Create data segments (all the work happens here)
208   if ( $tensortree ) {
209          do_tree_bsdf();
210   } else {
211          do_matrix_bsdf();
212   }
213 < # Output XML epilogue
214 < print
215 < '</Layer>
216 < </Optical>
217 < </WindowElement>
218 < ';
213 > # Output XML
214 > my $old_fh = select(STDOUT);
215 > $| = 1;
216 > select($old_fh);
217 > print "<!-- Created by: genBSDF @savedARGV -->\n";
218 > # print STDERR "Running: $wrapper\n";
219 > system $wrapper;
220 > die "Could not wrap BSDF data\n" if ( $? );
221   # Clean up temporary files and exit
222 < exec("rm -rf $td");
222 > system $rmtmp;
223  
224   #-------------- End of main program segment --------------#
225  
226   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
227   sub do_tree_bsdf {
160 # Shirley-Chiu mapping from unit square to disk
161 $sq2disk = '
162 in_square_a = 2*in_square_x - 1;
163 in_square_b = 2*in_square_y - 1;
164 in_square_rgn = if(in_square_a + in_square_b,
165                        if(in_square_a - in_square_b, 1, 2),
166                        if(in_square_b - in_square_a, 3, 4));
167 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
168                        -in_square_a, -in_square_b);
169 out_disk_phi = PI/4 * select(in_square_rgn,
170                                in_square_b/in_square_a,
171                                2 - in_square_a/in_square_b,
172                                4 + in_square_b/in_square_a,
173                                if(in_square_b*in_square_b,
174                                        6 - in_square_a/in_square_b, 0));
175 Dx = out_disk_r*cos(out_disk_phi);
176 Dy = out_disk_r*sin(out_disk_phi);
177 Dz = sqrt(1 - out_disk_r*out_disk_r);
178 ';
179 # Shirley-Chiu mapping from unit disk to square
180 $disk2sq = '
181 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
182 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
183 in_disk_phi = norm_radians(atan2(Dy, Dx));
184 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
185 out_square_a = select(in_disk_rgn,
186                        in_disk_r,
187                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
188                        -in_disk_r,
189                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
190 out_square_b = select(in_disk_rgn,
191                        in_disk_phi*in_disk_r/(PI/4),
192                        in_disk_r,
193                        (PI - in_disk_phi)*in_disk_r/(PI/4),
194                        -in_disk_r);
195 out_square_x = (out_square_a + 1)/2;
196 out_square_y = (out_square_b + 1)/2;
197 ';
198 # Announce ourselves in XML output
199 print "\t<DataDefinition>\n";
200 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
201 print "\t</DataDefinition>\n";
228  
229 < # Start rcontrib processes for compute each side
230 < do_tree_rtcontrib(0) if ( $doback );
231 < do_tree_rtcontrib(1) if ( $doforw );
229 >        # Run rfluxmtx processes to compute each side
230 >        do_ttree_dir(0) if ( $doback );
231 >        do_ttree_dir(1) if ( $doforw );
232  
233   }       # end of sub do_tree_bsdf()
234  
235 < # Run rcontrib process to generate tensor tree samples
236 < sub do_tree_rtcontrib {
235 > # Call rfluxmtx and process tensor tree BSDF for the given direction
236 > sub do_ttree_dir {
237          my $forw = shift;
238 <        my $matargs = "-m $bmodnm";
213 <        if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
214 <        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
215 <                "-e '$disk2sq' -bn '$ns*$ns' " .
216 <                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
217 <                "-o $td/%s.flt $matargs $octree";
238 >        my $cmd;
239          if ( $tensortree == 3 ) {
240                  # Isotropic BSDF
241                  my $ns2 = $ns / 2;
242 <                $cmd = "cnt $ns2 $ny $nx " .
243 <                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
244 <                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
245 <                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
246 <                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
247 <                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
248 <                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
249 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
250 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
251 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
252 <                        "| $cmd";
242 >                if ($windoz) {
243 >                        $cmd = "cnt $ns2 $ny $nx " .
244 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
245 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
246 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
247 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
248 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
249 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
250 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
251 >                                qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
252 >                                qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
253 >                                "| $rfluxmtx -fa -y $ns2 - $receivers -i $octree";
254 >                } else {
255 >                        $cmd = "cnt $ns2 $ny $nx " .
256 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
257 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
258 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
259 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
260 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
261 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
262 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
263 >                                qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
264 >                                qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
265 >                                "| $rfluxmtx -h -ff -y $ns2 - $receivers -i $octree";
266 >                }
267          } else {
268                  # Anisotropic BSDF
269 <                # Sample area vertically to improve load balance, since
270 <                # shading systems usually have bilateral symmetry (L-R)
271 <                $cmd = "cnt $ns $ns $ny $nx " .
272 <                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
273 <                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
274 <                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
240 <                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
241 <                        "-e 'in_square_x=(\$1+r1)/$ns' " .
242 <                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
243 <                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
244 <                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
245 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
246 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
247 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
248 <                        "| $cmd";
269 >                my $sender = ($bsender,$fsender)[$forw];
270 >                if ($windoz) {
271 >                        $cmd = "$rfluxmtx -fa $sender $receivers -i $octree";
272 >                } else {
273 >                        $cmd = "$rfluxmtx -h -ff $sender $receivers -i $octree";
274 >                }
275          }
276 < # print STDERR "Starting: $cmd\n";
277 <        system "$cmd" || die "Failure running rcontrib";
276 >        # print STDERR "Starting: $cmd\n";
277 >        system $cmd;
278 >        die "Failure running rfluxmtx" if ( $? );
279          ttree_out($forw);
280 < }       # end of do_tree_rtcontrib()
280 > }       # end of do_ttree_dir()
281  
282 < # Simplify and output tensor tree results
282 > # Simplify and store tensor tree results
283   sub ttree_out {
284          my $forw = shift;
285 <        my $side = ("Back","Front")[$forw];
286 <        my $cmd;
287 < # Only output one transmitted anisotropic distribution, preferring backwards
288 < if ( !$forw || !$doback || $tensortree==3 ) {
289 < print
290 < '       <WavelengthData>
291 <                <LayerNumber>System</LayerNumber>
265 <                <Wavelength unit="Integral">Visible</Wavelength>
266 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
267 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
268 <                <WavelengthDataBlock>
269 < ';
270 < print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
271 < print
272 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
273 <                        <ScatteringDataType>BTDF</ScatteringDataType>
274 <                        <ScatteringData>
275 < ';
276 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
277 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
278 < if ($pctcull >= 0) {
279 <        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
280 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
281 <        system "$cmd" || die "Failure running rttree_reduce";
282 < } else {
283 <        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
284 <        print "{\n";
285 <        system "$cmd" || die "Failure running rcalc";
286 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
287 <                print "0\n";
285 >        my ($refldat,$transdat);
286 >        if ( $forw ) {
287 >                $transdat = $facedat;
288 >                $refldat = $behinddat;
289 >        } else {
290 >                $transdat = $behinddat;
291 >                $refldat = $facedat;
292          }
293 <        print "}\n";
294 < }
295 < print
296 < '                       </ScatteringData>
297 <                </WavelengthDataBlock>
298 <        </WavelengthData>
299 < ';
300 < }
297 < # Output reflection
298 < print
299 < '       <WavelengthData>
300 <                <LayerNumber>System</LayerNumber>
301 <                <Wavelength unit="Integral">Visible</Wavelength>
302 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
303 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
304 <                <WavelengthDataBlock>
305 < ';
306 < print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
307 < print
308 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
309 <                        <ScatteringDataType>BTDF</ScatteringDataType>
310 <                        <ScatteringData>
311 < ';
312 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
313 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
314 < if ($pctcull >= 0) {
315 <        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
316 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
317 <        system "$cmd" || die "Failure running rttree_reduce";
318 < } else {
319 <        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
320 <        print "{\n";
321 <        system "$cmd" || die "Failure running rcalc";
322 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
323 <                print "0\n";
293 >        # Only output one transmitted anisotropic distribution, preferring backwards
294 >        if ( !$forw || !$doback || $tensortree==3 ) {
295 >                my $ttyp = ("tb","tf")[$forw];
296 >                ttree_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
297 >                if ( $docolor ) {
298 >                        ttree_comp($ttyp, "CIE-X", $transdat, ($tbx,$tfx)[$forw]);
299 >                        ttree_comp($ttyp, "CIE-Z", $transdat, ($tbz,$tfz)[$forw]);
300 >                }
301          }
302 <        print "}\n";
303 < }
304 < print
305 < '                       </ScatteringData>
306 <                </WavelengthDataBlock>
307 <        </WavelengthData>
308 < ';
302 >        # Output reflection
303 >        my $rtyp = ("rb","rf")[$forw];
304 >        ttree_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
305 >        if ( $docolor ) {
306 >                ttree_comp($rtyp, "CIE-X", $refldat, ($rbx,$rfx)[$forw]);
307 >                ttree_comp($rtyp, "CIE-Z", $refldat, ($rbz,$rfz)[$forw]);
308 >        }
309   }       # end of ttree_out()
310  
311 + # Call rttree_reduce on the given component
312 + sub ttree_comp {
313 +        my $typ = shift;
314 +        my $spec = shift;
315 +        my $src = shift;
316 +        my $dest = shift;
317 +        my $cmd;
318 +        if ($windoz) {
319 +                if ("$spec" eq "Visible") {
320 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
321 +                                q{-e "$1=(0.265*$1+0.670*$2+0.065*$3)/Omega"};
322 +                } elsif ("$spec" eq "CIE-X") {
323 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
324 +                                q{-e "$1=(0.514*$1+0.324*$2+0.162*$3)/Omega"};
325 +                } elsif ("$spec" eq "CIE-Z") {
326 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
327 +                                q{-e "$1=(0.024*$1+0.123*$2+0.853*$3)/Omega"};
328 +                }
329 +        } else {
330 +                if ("$spec" eq "Visible") {
331 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
332 +                                q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega'};
333 +                } elsif ("$spec" eq "CIE-X") {
334 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
335 +                                q{-e '$1=(0.514*$1+0.324*$2+0.162*$3)/Omega'};
336 +                } elsif ("$spec" eq "CIE-Z") {
337 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
338 +                                q{-e '$1=(0.024*$1+0.123*$2+0.853*$3)/Omega'};
339 +                }
340 +        }
341 +        if ($pctcull >= 0) {
342 +                my $avg = ( "$typ" =~ /^r[fb]/ ) ? " -a" : "";
343 +                if ($windoz) {
344 +                        $cmd = "rcollate -ho -oc 1 $src | " .
345 +                                        $cmd .
346 +                                        " | rttree_reduce$avg -h -fa -t $pctcull -r $tensortree -g $ttlog2";
347 +                } else {
348 +                        $cmd .= " -of $src " .
349 +                                        "| rttree_reduce$avg -h -ff -t $pctcull -r $tensortree -g $ttlog2";
350 +                }
351 +                # print STDERR "Running: $cmd\n";
352 +                system "$cmd > $dest";
353 +                die "Failure running rttree_reduce" if ( $? );
354 +        } else {
355 +                if ($windoz) {
356 +                        $cmd = "rcollate -ho -oc 1 $src | " . $cmd ;
357 +                } else {
358 +                        $cmd .= " $src";
359 +                }
360 +                open(DATOUT, "> $dest");
361 +                print DATOUT "{\n";
362 +                close DATOUT;
363 +                # print STDERR "Running: $cmd\n";
364 +                system "$cmd >> $dest";
365 +                die "Failure running rcalc" if ( $? );
366 +                open(DATOUT, ">> $dest");
367 +                for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
368 +                        print DATOUT "0\n";
369 +                }
370 +                print DATOUT "}\n";
371 +                close DATOUT;
372 +        }
373 +        if ( "$spec" ne "$curspec" ) {
374 +                $wrapper .= " -s $spec";
375 +                $curspec = $spec;
376 +        }
377 +        $wrapper .= " -$typ $dest";
378 + }       # end of ttree_comp()
379 +
380   #------------- End of do_tree_bsdf() & subroutines -------------#
381  
382   #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
383   sub do_matrix_bsdf {
384 < # Set up sampling of portal
385 < # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
386 < $tcal = '
387 < DEGREE : PI/180;
388 < sq(x) : x*x;
389 < Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
390 < Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
391 < Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
392 < Kmax : Kaccum(Knaz(0));
393 < Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
394 < Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
395 < Kcol = Kbin - Kaccum(Krow-1);
396 < Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
397 < Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
398 < sin_kpol = sin(Kpol);
399 < Dx = cos(Kazi)*sin_kpol;
400 < Dy = sin(Kazi)*sin_kpol;
401 < Dz = sqrt(1 - sin_kpol*sin_kpol);
402 < KprojOmega = PI * if(Kbin-.5,
403 <        (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
404 <        1 - sq(cos(Kpola(1)*DEGREE)));
405 < ';
406 < # Compute Klems bin from exiting ray direction (forward or backward)
407 < $kcal = '
408 < DEGREE : PI/180;
409 < abs(x) : if(x, x, -x);
410 < Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
411 < posangle(a) : if(-a, a + 2*PI, a);
366 < Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
367 < kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
368 < knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
369 < kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
370 < kfindrow(r, pol) : if(r-kpola(0)+.5, r,
371 <                if(pol-kpola(r), kfindrow(r+1, pol), r) );
372 < kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
373 < kbin2(pol,azi) = select(kfindrow(1, pol),
374 <                kazn(azi,360/knaz(1)),
375 <                kaccum(1) + kazn(azi,360/knaz(2)),
376 <                kaccum(2) + kazn(azi,360/knaz(3)),
377 <                kaccum(3) + kazn(azi,360/knaz(4)),
378 <                kaccum(4) + kazn(azi,360/knaz(5)),
379 <                kaccum(5) + kazn(azi,360/knaz(6)),
380 <                kaccum(6) + kazn(azi,360/knaz(7)),
381 <                kaccum(7) + kazn(azi,360/knaz(8)),
382 <                kaccum(8) + kazn(azi,360/knaz(9))
383 <        );
384 < kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
385 < ';
386 < my $ndiv = 145;
387 < # Compute scattering data using rcontrib
388 < my @tfarr;
389 < my @rfarr;
390 < my @tbarr;
391 < my @rbarr;
392 < my $cmd;
393 < my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
394 <        "-e '$kcal' -b kbin -bn $ndiv " .
395 <        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
396 < my $rccmd = "rcalc -e '$tcal' " .
397 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
398 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
399 < if ( $doforw ) {
400 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
401 <        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
402 <        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
403 <        "-e 'zp:$dim[4]' " .
404 <        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
405 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
406 <        "| $rtcmd";
407 < system "$cmd" || die "Failure running: $cmd\n";
408 < @tfarr = `$rccmd $td/$fmodnm.flt`;
409 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
410 < chomp(@tfarr);
411 < @rfarr = `$rccmd $td/$bmodnm.flt`;
412 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
413 < chomp(@rfarr);
414 < }
415 < if ( $doback ) {
416 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
417 <        "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
418 <        "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
419 <        "-e 'zp:$dim[5]' " .
420 <        q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
421 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
422 <        "| $rtcmd";
423 < system "$cmd" || die "Failure running: $cmd\n";
424 < @tbarr = `$rccmd $td/$bmodnm.flt`;
425 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
426 < chomp(@tbarr);
427 < @rbarr = `$rccmd $td/$fmodnm.flt`;
428 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
429 < chomp(@rbarr);
430 < }
431 < # Output angle basis
432 < print
433 < '       <DataDefinition>
434 <                <IncidentDataStructure>Columns</IncidentDataStructure>
435 <                <AngleBasis>
436 <                        <AngleBasisName>LBNL/Klems Full</AngleBasisName>
437 <                        <AngleBasisBlock>
438 <                        <Theta>0</Theta>
439 <                        <nPhis>1</nPhis>
440 <                        <ThetaBounds>
441 <                                <LowerTheta>0</LowerTheta>
442 <                                <UpperTheta>5</UpperTheta>
443 <                        </ThetaBounds>
444 <                        </AngleBasisBlock>
445 <                        <AngleBasisBlock>
446 <                        <Theta>10</Theta>
447 <                        <nPhis>8</nPhis>
448 <                        <ThetaBounds>
449 <                                <LowerTheta>5</LowerTheta>
450 <                                <UpperTheta>15</UpperTheta>
451 <                        </ThetaBounds>
452 <                        </AngleBasisBlock>
453 <                        <AngleBasisBlock>
454 <                        <Theta>20</Theta>
455 <                        <nPhis>16</nPhis>
456 <                        <ThetaBounds>
457 <                                <LowerTheta>15</LowerTheta>
458 <                                <UpperTheta>25</UpperTheta>
459 <                        </ThetaBounds>
460 <                        </AngleBasisBlock>
461 <                        <AngleBasisBlock>
462 <                        <Theta>30</Theta>
463 <                        <nPhis>20</nPhis>
464 <                        <ThetaBounds>
465 <                                <LowerTheta>25</LowerTheta>
466 <                                <UpperTheta>35</UpperTheta>
467 <                        </ThetaBounds>
468 <                        </AngleBasisBlock>
469 <                        <AngleBasisBlock>
470 <                        <Theta>40</Theta>
471 <                        <nPhis>24</nPhis>
472 <                        <ThetaBounds>
473 <                                <LowerTheta>35</LowerTheta>
474 <                                <UpperTheta>45</UpperTheta>
475 <                        </ThetaBounds>
476 <                        </AngleBasisBlock>
477 <                        <AngleBasisBlock>
478 <                        <Theta>50</Theta>
479 <                        <nPhis>24</nPhis>
480 <                        <ThetaBounds>
481 <                                <LowerTheta>45</LowerTheta>
482 <                                <UpperTheta>55</UpperTheta>
483 <                        </ThetaBounds>
484 <                        </AngleBasisBlock>
485 <                        <AngleBasisBlock>
486 <                        <Theta>60</Theta>
487 <                        <nPhis>24</nPhis>
488 <                        <ThetaBounds>
489 <                                <LowerTheta>55</LowerTheta>
490 <                                <UpperTheta>65</UpperTheta>
491 <                        </ThetaBounds>
492 <                        </AngleBasisBlock>
493 <                        <AngleBasisBlock>
494 <                        <Theta>70</Theta>
495 <                        <nPhis>16</nPhis>
496 <                        <ThetaBounds>
497 <                                <LowerTheta>65</LowerTheta>
498 <                                <UpperTheta>75</UpperTheta>
499 <                        </ThetaBounds>
500 <                        </AngleBasisBlock>
501 <                        <AngleBasisBlock>
502 <                        <Theta>82.5</Theta>
503 <                        <nPhis>12</nPhis>
504 <                        <ThetaBounds>
505 <                                <LowerTheta>75</LowerTheta>
506 <                                <UpperTheta>90</UpperTheta>
507 <                        </ThetaBounds>
508 <                        </AngleBasisBlock>
509 <                </AngleBasis>
510 <        </DataDefinition>
511 < ';
512 < if ( $doforw ) {
513 < print
514 < '       <WavelengthData>
515 <                <LayerNumber>System</LayerNumber>
516 <                <Wavelength unit="Integral">Visible</Wavelength>
517 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
518 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
519 <                <WavelengthDataBlock>
520 <                        <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
521 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
522 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
523 <                        <ScatteringDataType>BTDF</ScatteringDataType>
524 <                        <ScatteringData>
525 < ';
526 < # Output front transmission (transposed order)
527 < for (my $od = 0; $od < $ndiv; $od++) {
528 <        for (my $id = 0; $id < $ndiv; $id++) {
529 <                print $tfarr[$ndiv*$id + $od], ",\n";
384 >
385 >        # Run rfluxmtx processes to compute each side
386 >        do_matrix_dir(0) if ( $doback );
387 >        do_matrix_dir(1) if ( $doforw );
388 >
389 > }       # end of sub do_matrix_bsdf()
390 >
391 > # Call rfluxmtx and process tensor tree BSDF for the given direction
392 > sub do_matrix_dir {
393 >        my $forw = shift;
394 >        my $cmd;
395 >        my $sender = ($bsender,$fsender)[$forw];
396 >        $cmd = "$rfluxmtx -fd $sender $receivers -i $octree";
397 >        # print STDERR "Starting: $cmd\n";
398 >        system $cmd;
399 >        die "Failure running rfluxmtx" if ( $? );
400 >        matrix_out($forw);
401 > }       # end of do_matrix_dir()
402 >
403 > sub matrix_out {
404 >        my $forw = shift;
405 >        my ($refldat,$transdat);
406 >        if ( $forw ) {
407 >                $transdat = $facedat;
408 >                $refldat = $behinddat;
409 >        } else {
410 >                $transdat = $behinddat;
411 >                $refldat = $facedat;
412          }
413 <        print "\n";
414 < }
415 < print
416 < '                       </ScatteringData>
417 <                </WavelengthDataBlock>
418 <        </WavelengthData>
537 <        <WavelengthData>
538 <                <LayerNumber>System</LayerNumber>
539 <                <Wavelength unit="Integral">Visible</Wavelength>
540 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
541 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
542 <                <WavelengthDataBlock>
543 <                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
544 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
545 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
546 <                        <ScatteringDataType>BTDF</ScatteringDataType>
547 <                        <ScatteringData>
548 < ';
549 < # Output front reflection (transposed order)
550 < for (my $od = 0; $od < $ndiv; $od++) {
551 <        for (my $id = 0; $id < $ndiv; $id++) {
552 <                print $rfarr[$ndiv*$id + $od], ",\n";
413 >        # Output transmission
414 >        my $ttyp = ("tb","tf")[$forw];
415 >        matrix_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
416 >        if ( $docolor ) {
417 >                matrix_comp($ttyp, "CIE-X", $transdat, ($tbx,$tfx)[$forw]);
418 >                matrix_comp($ttyp, "CIE-Z", $transdat, ($tbz,$tfz)[$forw]);
419          }
420 <        print "\n";
421 < }
422 < print
423 < '                       </ScatteringData>
424 <                </WavelengthDataBlock>
425 <        </WavelengthData>
560 < ';
561 < }
562 < if ( $doback ) {
563 < print
564 < '       <WavelengthData>
565 <                <LayerNumber>System</LayerNumber>
566 <                <Wavelength unit="Integral">Visible</Wavelength>
567 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
568 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
569 <                <WavelengthDataBlock>
570 <                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
571 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
572 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
573 <                        <ScatteringDataType>BTDF</ScatteringDataType>
574 <                        <ScatteringData>
575 < ';
576 < # Output back transmission (transposed order)
577 < for (my $od = 0; $od < $ndiv; $od++) {
578 <        for (my $id = 0; $id < $ndiv; $id++) {
579 <                print $tbarr[$ndiv*$id + $od], ",\n";
420 >        # Output reflection
421 >        my $rtyp = ("rb","rf")[$forw];
422 >        matrix_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
423 >        if ( $docolor ) {
424 >                matrix_comp($rtyp, "CIE-X", $refldat, ($rbx,$rfx)[$forw]);
425 >                matrix_comp($rtyp, "CIE-Z", $refldat, ($rbz,$rfz)[$forw]);
426          }
427 <        print "\n";
428 < }
429 < print
430 < '                       </ScatteringData>
431 <                </WavelengthDataBlock>
432 <        </WavelengthData>
433 <        <WavelengthData>
434 <                <LayerNumber>System</LayerNumber>
435 <                <Wavelength unit="Integral">Visible</Wavelength>
436 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
437 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
438 <                <WavelengthDataBlock>
439 <                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
440 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
441 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
596 <                        <ScatteringDataType>BTDF</ScatteringDataType>
597 <                        <ScatteringData>
598 < ';
599 < # Output back reflection (transposed order)
600 < for (my $od = 0; $od < $ndiv; $od++) {
601 <        for (my $id = 0; $id < $ndiv; $id++) {
602 <                print $rbarr[$ndiv*$id + $od], ",\n";
427 > }       # end of matrix_out()
428 >
429 > # Transpose matrix component data and save to file
430 > sub matrix_comp {
431 >        my $typ = shift;
432 >        my $spec = shift;
433 >        my $src = shift;
434 >        my $dest = shift;
435 >        my $cmd = "rmtxop -fa -t";
436 >        if ("$spec" eq "Visible") {
437 >                $cmd .= " -c 0.265 0.670 0.065";
438 >        } elsif ("$spec" eq "CIE-X") {
439 >                $cmd .= " -c 0.514 0.324 0.162";
440 >        } elsif ("$spec" eq "CIE-Z") {
441 >                $cmd .= " -c 0.024 0.123 0.853";
442          }
443 <        print "\n";
444 < }
445 < print
446 < '                       </ScatteringData>
447 <                </WavelengthDataBlock>
448 <        </WavelengthData>
449 < ';
450 < }
451 < }
452 < #------------- End of do_matrix_bsdf() --------------#
443 >        $cmd .= " $src | rcollate -ho";
444 >        # print STDERR "Running: $cmd\n";
445 >        system "$cmd > $dest";
446 >        die "Failure running rttree_reduce" if ( $? );
447 >        if ( "$spec" ne "$curspec" ) {
448 >                $wrapper .= " -s $spec";
449 >                $curspec = $spec;
450 >        }
451 >        $wrapper .= " -$typ $dest";
452 > }       # end of matrix_comp()
453 >
454 > #------------- End of do_matrix_bsdf() & subroutines --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines